diff -r 091f89c47ad9 trytond/modules/stock/shipment.py
--- a/trytond/modules/stock/shipment.py	Mon Sep 10 15:28:38 2012 +0200
+++ b/trytond/modules/stock/shipment.py	Mon Sep 24 20:36:42 2012 +0200
@@ -9,9 +9,22 @@
 from trytond.backend import TableHandler
 from trytond.pyson import Eval, Not, Equal, If, Or, And, Bool, In, Get, Id
 from trytond.transaction import Transaction
-from trytond.pool import Pool
+from trytond.pool import Pool, PoolMeta
 from trytond.tools import reduce_ids
 
+__all__ = ['ShipmentIn', 'ShipmentInReturn',
+    'ShipmentOut', 'ShipmentOutReturn',
+    'AssignShipmentOutAssignFailed', 'AssignShipmentOut',
+    'ShipmentInternal',
+    'Address',
+    'AssignShipmentInternalAssignFailed', 'AssignShipmentInternal',
+    'AssignShipmentInReturnAssignFailed', 'AssignShipmentInReturn',
+    'CreateShipmentOutReturn',
+    'DeliveryNote', 'PickingList',
+    'SupplierRestockingList', 'CustomerReturnRestockingList',
+    'InteralShipmentReport']
+__metaclass__ = PoolMeta
+
 STATES = {
     'readonly': "state in ('cancel', 'done')",
 }
@@ -19,10 +32,8 @@
 
 class ShipmentIn(Workflow, ModelSQL, ModelView):
     "Supplier Shipment"
-    _name = 'stock.shipment.in'
-    _description = __doc__
+    __name__ = 'stock.shipment.in'
     _rec_name = 'code'
-
     effective_date = fields.Date('Effective Date', readonly=True)
     planned_date = fields.Date('Planned Date', states={
             'readonly': Not(Equal(Eval('state'), 'draft')),
@@ -48,7 +59,7 @@
         depends=['state', 'incoming_moves', 'supplier'])
     supplier_location = fields.Function(fields.Many2One('stock.location',
             'Supplier Location', on_change_with=['supplier']),
-        'get_supplier_location')
+        'on_change_with_supplier_location')
     contact_address = fields.Many2One('party.address', 'Contact Address',
         states={
             'readonly': Not(Equal(Eval('state'), 'draft')),
@@ -62,10 +73,10 @@
             }, depends=['state', 'incoming_moves'])
     warehouse_input = fields.Function(fields.Many2One('stock.location',
             'Warehouse Input', on_change_with=['warehouse']),
-        'get_warehouse_input')
+        'on_change_with_warehouse_input')
     warehouse_storage = fields.Function(fields.Many2One('stock.location',
             'Warehouse Storage', on_change_with=['warehouse']),
-        'get_warehouse_storage')
+        'on_change_with_warehouse_storage')
     incoming_moves = fields.Function(fields.One2Many('stock.move', None,
             'Incoming Moves',
             add_remove=[
@@ -111,10 +122,11 @@
         ('received', 'Received'),
         ], 'State', readonly=True)
 
-    def __init__(self):
-        super(ShipmentIn, self).__init__()
-        self._order[0] = ('id', 'DESC')
-        self._error_messages.update({
+    @classmethod
+    def __setup__(cls):
+        super(ShipmentIn, cls).__setup__()
+        cls._order[0] = ('id', 'DESC')
+        cls._error_messages.update({
                 'incoming_move_input_dest': 'Incoming Moves must have ' \
                     'the warehouse input location as destination location!',
                 'inventory_move_input_source': 'Inventory Moves must ' \
@@ -122,14 +134,14 @@
                 'delete_cancel': 'Supplier Shipment "%s" must be cancelled '\
                     'before deletion!',
                 })
-        self._transitions |= set((
+        cls._transitions |= set((
                 ('draft', 'received'),
                 ('received', 'done'),
                 ('draft', 'cancel'),
                 ('received', 'cancel'),
                 ('cancel', 'draft'),
                 ))
-        self._buttons.update({
+        cls._buttons.update({
                 'cancel': {
                     'invisible': Eval('state').in_(['cancel', 'done']),
                     },
@@ -144,7 +156,8 @@
                     },
                 })
 
-    def init(self, module_name):
+    @classmethod
+    def __register__(cls, module_name):
         cursor = Transaction().cursor
         # Migration from 1.2: packing renamed into shipment
         cursor.execute("UPDATE ir_model_data "\
@@ -164,8 +177,8 @@
 
         old_table = 'stock_packing_in'
         if TableHandler.table_exist(cursor, old_table):
-            TableHandler.table_rename(cursor, old_table, self._table)
-        table = TableHandler(cursor, self, module_name)
+            TableHandler.table_rename(cursor, old_table, cls._table)
+        table = TableHandler(cursor, cls, module_name)
         for field in ('create_uid', 'write_uid', 'contact_address',
                 'warehouse', 'supplier'):
             table.drop_fk(field, table=old_table)
@@ -175,190 +188,163 @@
         # Migration from 2.0:
         created_company = table.column_exist('company')
 
-        super(ShipmentIn, self).init(module_name)
+        super(ShipmentIn, cls).__register__(module_name)
 
         # Migration from 2.0:
-        move_obj = Pool().get('stock.move')
+        Move = Pool().get('stock.move')
         if (not created_company
-                and TableHandler.table_exist(cursor, move_obj._table)):
+                and TableHandler.table_exist(cursor, Move._table)):
             cursor.execute('SELECT shipment.id, MAX(move.company) '
                 'FROM "%s" AS shipment '
                 'INNER JOIN "%s" AS move ON shipment.id = move.shipment_in '
                 'GROUP BY shipment.id '
                 'ORDER BY MAX(move.company)'
-                % (self._table, move_obj._table))
+                % (cls._table, Move._table))
             for company_id, values in itertools.groupby(cursor.fetchall(),
                     operator.itemgetter(1)):
                 shipment_ids = [x[0] for x in values]
                 for i in range(0, len(shipment_ids), cursor.IN_MAX):
                     sub_ids = shipment_ids[i:i + cursor.IN_MAX]
                     red_sql, red_ids = reduce_ids('id', sub_ids)
-                    cursor.execute('UPDATE "' + self._table + '" '
+                    cursor.execute('UPDATE "' + cls._table + '" '
                         'SET company = %s WHERE ' + red_sql,
                         [company_id] + red_ids)
             table.not_null_action('company', action='add')
 
         # Add index on create_date
-        table = TableHandler(cursor, self, module_name)
+        table = TableHandler(cursor, cls, module_name)
         table.index_action('create_date', action='add')
 
-    def default_state(self):
+    @staticmethod
+    def default_state():
         return 'draft'
 
-    def default_warehouse(self):
-        location_obj = Pool().get('stock.location')
-        location_ids = location_obj.search(self.warehouse.domain)
-        if len(location_ids) == 1:
-            return location_ids[0]
+    @classmethod
+    def default_warehouse(cls):
+        Location = Pool().get('stock.location')
+        locations = Location.search(cls.warehouse.domain)
+        if len(locations) == 1:
+            return locations[0].id
 
-    def default_company(self):
+    @staticmethod
+    def default_company():
         return Transaction().context.get('company')
 
-    def on_change_supplier(self, values):
-        if not values.get('supplier'):
+    def on_change_supplier(self):
+        if not self.supplier:
             return {'contact_address': None}
-        party_obj = Pool().get("party.party")
-        address_id = party_obj.address_get(values['supplier'])
-        return {'contact_address': address_id}
+        address = self.supplier.address_get()
+        return {'contact_address': address.id}
 
-    def on_change_with_supplier_location(self, values):
-        pool = Pool()
-        party_obj = pool.get('party.party')
-        if values.get('supplier'):
-            supplier = party_obj.browse(values['supplier'])
-            return supplier.supplier_location.id
+    def on_change_with_supplier_location(self, name=None):
+        if self.supplier:
+            return self.supplier.supplier_location.id
 
-    def get_supplier_location(self, ids, name):
-        locations = {}
-        for shipment in self.browse(ids):
-            locations[shipment.id] = shipment.supplier.supplier_location.id
-        return locations
+    @classmethod
+    def default_warehouse_input(cls):
+        warehouse = cls.default_warehouse()
+        if warehouse:
+            return cls(warehouse=warehouse).on_change_with_warehouse_input()
 
-    def default_warehouse_input(self):
-        warehouse = self.default_warehouse()
+    def on_change_with_warehouse_input(self, name=None):
+        if self.warehouse:
+            return self.warehouse.input_location.id
+
+    @classmethod
+    def default_warehouse_storage(cls):
+        warehouse = cls.default_warehouse()
         if warehouse:
-            value = self.on_change_with_warehouse_input({
-                    'warehouse': warehouse,
-                    })
-            return value
+            return cls(warehouse=warehouse).on_change_with_warehouse_storage()
 
-    def on_change_with_warehouse_input(self, values):
-        pool = Pool()
-        location_obj = pool.get('stock.location')
-        if values.get('warehouse'):
-            warehouse = location_obj.browse(values['warehouse'])
-            return warehouse.input_location.id
+    def on_change_with_warehouse_storage(self, name=None):
+        if self.warehouse:
+            return self.warehouse.storage_location.id
 
-    def get_warehouse_input(self, ids, name):
-        inputs = {}
-        for shipment in self.browse(ids):
-            inputs[shipment.id] = shipment.warehouse.input_location.id
-        return inputs
+    def get_incoming_moves(self, name):
+        moves = []
+        for move in self.moves:
+            if move.to_location.id == self.warehouse.input_location.id:
+                moves.append(move.id)
+        return moves
 
-    def default_warehouse_storage(self):
-        warehouse = self.default_warehouse()
-        if warehouse:
-            value = self.on_change_with_warehouse_storage({
-                    'warehouse': warehouse,
-                    })
-            return value
-
-    def on_change_with_warehouse_storage(self, values):
-        pool = Pool()
-        location_obj = pool.get('stock.location')
-        if values.get('warehouse'):
-            warehouse = location_obj.browse(values['warehouse'])
-            return warehouse.storage_location.id
-
-    def get_warehouse_storage(self, ids, name):
-        storages = {}
-        for shipment in self.browse(ids):
-            storages[shipment.id] = shipment.warehouse.storage_location.id
-        return storages
-
-    def get_incoming_moves(self, ids, name):
-        res = {}
-        for shipment in self.browse(ids):
-            res[shipment.id] = []
-            for move in shipment.moves:
-                if move.to_location.id == shipment.warehouse.input_location.id:
-                    res[shipment.id].append(move.id)
-        return res
-
-    def set_incoming_moves(self, ids, name, value):
+    @classmethod
+    def set_incoming_moves(cls, shipments, name, value):
         if not value:
             return
-        self.write(ids, {
-            'moves': value,
-            })
+        cls.write(shipments, {
+                'moves': value,
+                })
 
-    def get_inventory_moves(self, ids, name):
-        res = {}
-        for shipment in self.browse(ids):
-            res[shipment.id] = []
-            for move in shipment.moves:
-                if (move.from_location.id ==
-                        shipment.warehouse.input_location.id):
-                    res[shipment.id].append(move.id)
-        return res
+    def get_inventory_moves(self, name):
+        moves = []
+        for move in self.moves:
+            if (move.from_location.id ==
+                    self.warehouse.input_location.id):
+                moves.append(move.id)
+        return moves
 
-    def set_inventory_moves(self, ids, name, value):
+    @classmethod
+    def set_inventory_moves(cls, shipments, name, value):
         if not value:
             return
-        self.write(ids, {
-            'moves': value,
-            })
+        cls.write(shipments, {
+                'moves': value,
+                })
 
-    def _get_move_planned_date(self, shipment):
+    @property
+    def _move_planned_date(self):
         '''
         Return the planned date for incoming moves and inventory_moves
         '''
-        return shipment.planned_date, shipment.planned_date
+        return self.planned_date, self.planned_date
 
-    def _set_move_planned_date(self, shipment_ids):
+    @classmethod
+    def _set_move_planned_date(cls, shipments):
         '''
         Set planned date of moves for the shipments
         '''
-        move_obj = Pool().get('stock.move')
-        if isinstance(shipment_ids, (int, long)):
-            shipment_ids = [shipment_ids]
-        for shipment in self.browse(shipment_ids):
-            dates = self._get_move_planned_date(shipment)
+        Move = Pool().get('stock.move')
+        for shipment in shipments:
+            dates = shipment._move_planned_date
             incoming_date, inventory_date = dates
-            move_obj.write([x.id for x in shipment.incoming_moves
-                    if x.state not in ('assigned', 'done', 'cancel')], {
+            Move.write([m for m in shipment.incoming_moves
+                    if m.state not in ('assigned', 'done', 'cancel')], {
                     'planned_date': incoming_date,
                     })
-            move_obj.write([x.id for x in shipment.inventory_moves
-                    if x.state not in ('assigned', 'done', 'cancel')], {
+            Move.write([m for m in shipment.inventory_moves
+                    if m.state not in ('assigned', 'done', 'cancel')], {
                     'planned_date': inventory_date,
                     })
 
-    def create(self, values):
-        sequence_obj = Pool().get('ir.sequence')
-        config_obj = Pool().get('stock.configuration')
+    @classmethod
+    def create(cls, values):
+        pool = Pool()
+        Sequence = pool.get('ir.sequence')
+        Config = pool.get('stock.configuration')
 
         values = values.copy()
-        config = config_obj.browse(1)
-        values['code'] = sequence_obj.get_id(config.shipment_in_sequence.id)
-        shipment_id = super(ShipmentIn, self).create(values)
-        self._set_move_planned_date(shipment_id)
-        return shipment_id
+        config = Config(1)
+        values['code'] = Sequence.get_id(config.shipment_in_sequence)
+        shipment = super(ShipmentIn, cls).create(values)
+        cls._set_move_planned_date([shipment])
+        return shipment
 
-    def write(self, ids, values):
-        result = super(ShipmentIn, self).write(ids, values)
-        self._set_move_planned_date(ids)
-        return result
+    @classmethod
+    def write(cls, shipments, values):
+        super(ShipmentIn, cls).write(shipments, values)
+        cls._set_move_planned_date(shipments)
 
-    def copy(self, ids, default=None):
+    @classmethod
+    def copy(cls, shipments, default=None):
         if default is None:
             default = {}
         default = default.copy()
         default['inventory_moves'] = None
         default['incoming_moves'] = None
-        return super(ShipmentIn, self).copy(ids, default=default)
+        return super(ShipmentIn, cls).copy(shipments, default=default)
 
-    def _get_inventory_moves(self, incoming_move):
+    @classmethod
+    def _get_inventory_moves(cls, incoming_move):
         res = {}
         if incoming_move.quantity <= 0.0:
             return None
@@ -375,85 +361,82 @@
         res['company'] = incoming_move.company.id
         return res
 
-    def create_inventory_moves(self, shipments):
+    @classmethod
+    def create_inventory_moves(cls, shipments):
         for shipment in shipments:
             inventory_moves = []
             for incoming_move in shipment.incoming_moves:
-                vals = self._get_inventory_moves(incoming_move)
+                vals = cls._get_inventory_moves(incoming_move)
                 if vals:
                     inventory_moves.append(('create', vals))
             if inventory_moves:
-                self.write(shipment.id, {
+                cls.write([shipment], {
                     'inventory_moves': inventory_moves,
                     })
 
-    def delete(self, ids):
-        if isinstance(ids, (int, long)):
-            ids = [ids]
+    @classmethod
+    def delete(cls, shipments):
         # Cancel before delete
-        self.cancel(ids)
-        for shipment in self.browse(ids):
+        cls.cancel(shipments)
+        for shipment in shipments:
             if shipment.state != 'cancel':
-                self.raise_user_error('delete_cancel', shipment.rec_name)
-        return super(ShipmentIn, self).delete(ids)
+                cls.raise_user_error('delete_cancel', shipment.rec_name)
+        super(ShipmentIn, cls).delete(shipments)
 
+    @classmethod
     @ModelView.button
     @Workflow.transition('cancel')
-    def cancel(self, ids):
-        move_obj = Pool().get('stock.move')
-        shipments = self.browse(ids)
-        move_obj.write([m.id for s in shipments
+    def cancel(cls, shipments):
+        Move = Pool().get('stock.move')
+        Move.write([m for s in shipments
                 for m in s.incoming_moves + s.inventory_moves
                 if m.state not in ('cancel', 'done')], {
                 'state': 'cancel',
                 })
 
+    @classmethod
     @ModelView.button
     @Workflow.transition('draft')
-    def draft(self, ids):
-        move_obj = Pool().get('stock.move')
-        shipments = self.browse(ids)
-        move_obj.write([m.id for s in shipments for m in s.incoming_moves
+    def draft(cls, shipments):
+        Move = Pool().get('stock.move')
+        Move.write([m for s in shipments for m in s.incoming_moves
                 if m.state not in ('draft', 'done')], {
                 'state': 'draft',
                 })
-        move_obj.delete([m.id for s in shipments for m in s.inventory_moves
+        Move.delete([m for s in shipments for m in s.inventory_moves
                 if m.state in ('draft', 'cancel')])
 
+    @classmethod
     @ModelView.button
     @Workflow.transition('received')
-    def receive(self, ids):
-        move_obj = Pool().get('stock.move')
-        shipments = self.browse(ids)
-        move_obj.write([m.id for s in shipments for m in s.incoming_moves
+    def receive(cls, shipments):
+        Move = Pool().get('stock.move')
+        Move.write([m for s in shipments for m in s.incoming_moves
                 if m.state not in ('done', 'cancel')], {
                 'state': 'done',
                 })
-        self.create_inventory_moves(shipments)
+        cls.create_inventory_moves(shipments)
 
+    @classmethod
     @ModelView.button
     @Workflow.transition('done')
-    def done(self, ids):
-        move_obj = Pool().get('stock.move')
-        date_obj = Pool().get('ir.date')
-        shipments = self.browse(ids)
-        move_obj.write([m.id for s in shipments for m in s.inventory_moves
+    def done(cls, shipments):
+        pool = Pool()
+        Move = pool.get('stock.move')
+        Date = pool.get('ir.date')
+        Move.write([m for s in shipments for m in s.inventory_moves
                 if m.state not in ('done', 'cancel')], {
                 'state': 'done',
                 })
-        self.write(ids, {
-                'effective_date': date_obj.today(),
+        cls.write(shipments, {
+                'effective_date': Date.today(),
                 })
 
-ShipmentIn()
-
 
 class ShipmentInReturn(Workflow, ModelSQL, ModelView):
     "Supplier Return Shipment"
-    _name = 'stock.shipment.in.return'
-    _description = __doc__
+    __name__ = 'stock.shipment.in.return'
     _rec_name = 'code'
-
     effective_date = fields.Date('Effective Date', readonly=True)
     planned_date = fields.Date('Planned Date',
         states={
@@ -505,14 +488,15 @@
         ('done', 'Done'),
         ], 'State', readonly=True)
 
-    def __init__(self):
-        super(ShipmentInReturn, self).__init__()
-        self._order[0] = ('id', 'DESC')
-        self._error_messages.update({
+    @classmethod
+    def __setup__(cls):
+        super(ShipmentInReturn, cls).__setup__()
+        cls._order[0] = ('id', 'DESC')
+        cls._error_messages.update({
                 'delete_cancel': 'Supplier Return Shipment "%s" must be '\
                     'cancelled before deletion!',
                 })
-        self._transitions |= set((
+        cls._transitions |= set((
                 ('draft', 'waiting'),
                 ('waiting', 'assigned'),
                 ('waiting', 'draft'),
@@ -523,7 +507,7 @@
                 ('assigned', 'cancel'),
                 ('cancel', 'draft'),
                 ))
-        self._buttons.update({
+        cls._buttons.update({
                 'cancel': {
                     'invisible': Eval('state').in_(['cancel', 'done']),
                     },
@@ -549,13 +533,14 @@
                 'assign_force': {},
                 })
 
-    def init(self, module_name):
+    @classmethod
+    def __register__(cls, module_name):
         cursor = Transaction().cursor
         # Migration from 1.2: packing renamed into shipment
         old_table = 'stock_packing_in_return'
         if TableHandler.table_exist(cursor, old_table):
-            TableHandler.table_rename(cursor, old_table, self._table)
-        table = TableHandler(cursor, self, module_name)
+            TableHandler.table_rename(cursor, old_table, cls._table)
+        table = TableHandler(cursor, cls, module_name)
         for field in ('create_uid', 'write_uid', 'from_location',
                 'to_location'):
             table.drop_fk(field, table=old_table)
@@ -565,173 +550,177 @@
         # Migration from 2.0:
         created_company = table.column_exist('company')
 
-        super(ShipmentInReturn, self).init(module_name)
+        super(ShipmentInReturn, cls).__register__(module_name)
 
         # Migration from 2.0:
-        move_obj = Pool().get('stock.move')
+        Move = Pool().get('stock.move')
         if (not created_company
-                and TableHandler.table_exist(cursor, move_obj._table)):
+                and TableHandler.table_exist(cursor, Move._table)):
             cursor.execute('SELECT shipment.id, MAX(move.company) '
                 'FROM "%s" AS shipment '
                 'INNER JOIN "%s" AS move '
                 'ON shipment.id = move.shipment_in_return '
                 'GROUP BY shipment.id '
                 'ORDER BY MAX(move.company)'
-                % (self._table, move_obj._table))
+                % (cls._table, Move._table))
             for company_id, values in itertools.groupby(cursor.fetchall(),
                     operator.itemgetter(1)):
                 shipment_ids = [x[0] for x in values]
                 for i in range(0, len(shipment_ids), cursor.IN_MAX):
                     sub_ids = shipment_ids[i:i + cursor.IN_MAX]
                     red_sql, red_ids = reduce_ids('id', sub_ids)
-                    cursor.execute('UPDATE "' + self._table + '" '
+                    cursor.execute('UPDATE "' + cls._table + '" '
                         'SET company = %s WHERE ' + red_sql,
                         [company_id] + red_ids)
             table.not_null_action('company', action='add')
 
         # Add index on create_date
-        table = TableHandler(cursor, self, module_name)
+        table = TableHandler(cursor, cls, module_name)
         table.index_action('create_date', action='add')
 
-    def default_state(self):
+    @staticmethod
+    def default_state():
         return 'draft'
 
-    def default_company(self):
+    @staticmethod
+    def default_company():
         return Transaction().context.get('company')
 
-    def _get_move_planned_date(self, shipment):
+    @property
+    def _move_planned_date(self):
         '''
         Return the planned date for the moves
         '''
-        return shipment.planned_date
+        return self.planned_date
 
-    def _set_move_planned_date(self, shipment_ids):
+    @classmethod
+    def _set_move_planned_date(cls, shipments):
         '''
         Set planned date of moves for the shipments
         '''
-        move_obj = Pool().get('stock.move')
-        if isinstance(shipment_ids, (int, long)):
-            shipment_ids = [shipment_ids]
-        for shipment in self.browse(shipment_ids):
-            date = self._get_move_planned_date(shipment)
-            move_obj.write([x.id for x in shipment.moves
-                    if x.state not in ('assigned', 'done', 'cancel')], {
-                    'planned_date': date,
+        Move = Pool().get('stock.move')
+        for shipment in shipments:
+            Move.write([m for m in shipment.moves
+                    if m.state not in ('assigned', 'done', 'cancel')], {
+                    'planned_date': shipment._move_planned_date,
                     })
 
-    def create(self, values):
-        sequence_obj = Pool().get('ir.sequence')
-        config_obj = Pool().get('stock.configuration')
+    @classmethod
+    def create(cls, values):
+        pool = Pool()
+        Sequence = pool.get('ir.sequence')
+        Config = pool.get('stock.configuration')
 
         values = values.copy()
-        config = config_obj.browse(1)
-        values['code'] = sequence_obj.get_id(
-                config.shipment_in_return_sequence.id)
-        shipment_id = super(ShipmentInReturn, self).create(values)
-        self._set_move_planned_date(shipment_id)
-        return shipment_id
+        config = Config(1)
+        values['code'] = Sequence.get_id(
+            config.shipment_in_return_sequence.id)
+        shipment = super(ShipmentInReturn, cls).create(values)
+        cls._set_move_planned_date([shipment])
+        return shipment
 
-    def write(self, ids, values):
-        result = super(ShipmentInReturn, self).write(ids, values)
-        self._set_move_planned_date(ids)
-        return result
+    @classmethod
+    def write(cls, shipments, values):
+        super(ShipmentInReturn, cls).write(shipments, values)
+        cls._set_move_planned_date(shipments)
 
-    def delete(self, ids):
-        if isinstance(ids, (int, long)):
-            ids = [ids]
+    @classmethod
+    def delete(cls, shipments):
         # Cancel before delete
-        self.cancel(ids)
-        for shipment in self.browse(ids):
+        cls.cancel(shipments)
+        for shipment in shipments:
             if shipment.state != 'cancel':
-                self.raise_user_error('delete_cancel', shipment.rec_name)
-        return super(ShipmentInReturn, self).delete(ids)
+                cls.raise_user_error('delete_cancel', shipment.rec_name)
+        super(ShipmentInReturn, cls).delete(shipments)
 
+    @classmethod
     @ModelView.button
     @Workflow.transition('draft')
-    def draft(self, ids):
-        move_obj = Pool().get('stock.move')
-        shipments = self.browse(ids)
-        move_obj.write([m.id for s in shipments for m in s.moves
+    def draft(cls, shipments):
+        Move = Pool().get('stock.move')
+        Move.write([m for s in shipments for m in s.moves
                 if m.state not in ('draft', 'done')], {
                 'state': 'draft',
                 })
 
+    @classmethod
     @ModelView.button
     @Workflow.transition('waiting')
-    def wait(self, ids):
-        move_obj = Pool().get('stock.move')
-        shipments = self.browse(ids)
+    def wait(cls, shipments):
+        Move = Pool().get('stock.move')
         for shipment in shipments:
-            move_obj.write([m.id for m in shipment.moves
+            Move.write([m for m in shipment.moves
                     if m.state not in ('cancel', 'draft', 'done')], {
                     'state': 'draft',
-                    'planned_date': shipment.planned_date,
+                    'planned_date': shipment._move_planned_date,
                     })
 
+    @classmethod
     @Workflow.transition('assigned')
-    def assign(self, ids):
-        move_obj = Pool().get('stock.move')
-        shipments = self.browse(ids)
-        move_obj.write([m.id for s in shipments for m in s.moves
+    def assign(cls, shipments):
+        Move = Pool().get('stock.move')
+        Move.write([m for s in shipments for m in s.moves
                 if m.state not in ('assigned', 'cancel', 'done')], {
                 'state': 'assigned',
                 })
 
+    @classmethod
     @ModelView.button
     @Workflow.transition('done')
-    def done(self, ids):
-        move_obj = Pool().get('stock.move')
-        date_obj = Pool().get('ir.date')
+    def done(cls, shipments):
+        pool = Pool()
+        Move = pool.get('stock.move')
+        Date = pool.get('ir.date')
 
-        shipments = self.browse(ids)
-        move_obj.write([m.id for s in shipments for m in s.moves
+        Move.write([m for s in shipments for m in s.moves
                 if m.state not in ('done', 'cancel')], {
                 'state': 'done',
                 })
-        self.write(ids, {
-                'effective_date': date_obj.today(),
+        cls.write(shipments, {
+                'effective_date': Date.today(),
                 })
 
+    @classmethod
     @ModelView.button
     @Workflow.transition('cancel')
-    def cancel(self, ids):
-        move_obj = Pool().get('stock.move')
-        shipments = self.browse(ids)
-        move_obj.write([m.id for s in shipments for m in s.moves
+    def cancel(cls, shipments):
+        Move = Pool().get('stock.move')
+        Move.write([m for s in shipments for m in s.moves
                 if m.state not in ('cancel', 'done')], {
                 'state': 'cancel',
                 })
 
+    @classmethod
     @ModelView.button_action('stock.wizard_shipment_in_return_assign')
-    def assign_wizard(self, ids):
+    def assign_wizard(cls, shipments):
         pass
 
+    @classmethod
     @ModelView.button
-    def assign_try(self, ids):
+    def assign_try(cls, shipments):
         pool = Pool()
-        product_obj = pool.get('product.product')
-        uom_obj = pool.get('product.uom')
-        date_obj = pool.get('ir.date')
-        move_obj = pool.get('stock.move')
+        Product = pool.get('product.product')
+        Uom = pool.get('product.uom')
+        Date = pool.get('ir.date')
+        Move = pool.get('stock.move')
 
-        Transaction().cursor.lock(move_obj._table)
+        Transaction().cursor.lock(Move._table)
 
-        shipments = self.browse(ids)
         moves = [m for s in shipments for m in s.moves]
         location_ids = [m.from_location.id for m in moves]
         with Transaction().set_context(
-                stock_date_end=date_obj.today(),
+                stock_date_end=Date.today(),
                 stock_assign=True):
-            pbl = product_obj.products_by_location(location_ids=location_ids,
-                    product_ids=[m.product.id for m in moves])
+            pbl = Product.products_by_location(location_ids=location_ids,
+                product_ids=[m.product.id for m in moves])
 
         for move in moves:
             if move.state != 'draft':
                 continue
             if (move.from_location.id, move.product.id) in pbl:
                 qty_default_uom = pbl[(move.from_location.id, move.product.id)]
-                qty = uom_obj.compute_qty(move.product.default_uom,
-                        qty_default_uom, move.uom, round=False)
+                qty = Uom.compute_qty(move.product.default_uom,
+                    qty_default_uom, move.uom, round=False)
                 if qty < move.quantity:
                     return False
                 pbl[(move.from_location.id, move.product.id)] = (
